import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import peasy.test.*; 
import peasy.org.apache.commons.math.*; 
import peasy.*; 
import peasy.org.apache.commons.math.geometry.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class matthias_project_4 extends PApplet {

//created by Mohit Hingorani for MAT259 Winter 2015

/*
A simple 3D demo to introduce the concepts of 3D graphics in processing
Introducing only peasycam


press n , l , t for nubers, lines and text repectively
SQL query

select day(cout) , 
sum( case when  deweyClass > 000 and deweyClass < 100 then 1 else 0 end) as oonnee,
sum( case when  deweyClass > 100 and deweyClass < 200 then 1 else 0 end) as two,
sum( case when  deweyClass > 200 and deweyClass < 300 then 1 else 0 end) as three,
sum( case when  deweyClass > 300 and deweyClass < 400 then 1 else 0 end) as four,
sum( case when  deweyClass > 400 and deweyClass < 500 then 1 else 0 end) as five, 
sum( case when  deweyClass > 500 and deweyClass < 600 then 1 else 0 end) as six,
sum( case when  deweyClass > 600 and deweyClass < 700 then 1 else 0 end) as seven,
sum( case when  deweyClass > 700 and deweyClass < 800 then 1 else 0 end) as eight,
sum( case when  deweyClass > 800 and deweyClass < 900 then 1 else 0 end) as nine,
sum( case when  deweyClass > 900 and deweyClass < 1000 then 1 else 0 end) as ten

from inraw where itemtype= "acbk" and title like "% mind %" and date(cout) >= "2013-03-01" and date(cout) <= "2013-03-31" 
group by day(cout) order by day(cout) 


*/

// importing peasycam into processing, peasycam is used for manipualting the camera positions






// setting up PeasyCam
PeasyCam cam;


// setting up fonts for text
PFont  myFutura12 = createFont("Futura",12, true);
PFont  myFutura16 = createFont("Futura",16, true);
PFont  myFutura20 = createFont("Futura",20, true);


//to store the data table
int [][] dataMatrix = null;

String[] categories = { 
  "Adult VHS", "Adult DVD", "Youth VHS", "Youth DVD", "CD-ROM", 
  "Audio CD", "Audio Cassette", "Diskette", "Other"
};
String[] years = { 
  "2005", "2006", "2007", "2008", "2009", "2010", "2011", "2012"
};
// to store the maximum possible value
int maxCount; 

// intialzing number or rows & columns , can be modified later
int numRows;
int numColumns;

//  text formatting variables 
float constantMarginOnRows = 160;
float constantMarginOnColumns = 100;
Table table; 

float blockWidth = 40;
float blockHeight = 40;   // initial 80

float zTransform = 0; 

boolean textFlag= false;
boolean numberFlag = false;
boolean lineFlag = false; 

public void draw()
{
  // refresh the canvas everyframe
  background(255);
  //modifying the cell size according to window size

  // blockWidth = ( width - 2* constantMarginOnRows ) / numRows;      
  // blockHeight= ( height - 2* constantMarginOnColumns ) / numColumns;  

  translate( -width/2, -height/2);   // Peasycam intially sets lookAt() at (0,0,0) hence we need to transalte the axis

  // create base lines  
  //fill(255, 192);

  // creating grid lines in 3D

  if ( lineFlag)
  {
    stroke(64, 128);
    for ( int i =0; i <= blockWidth * (numRows); i+= blockWidth)
    {
      pushMatrix();                                                  //setting up a matrix to keep the current graphi coordinates
      translate(constantMarginOnRows, constantMarginOnColumns);      //translate to the correct position
      line( i, 0, 0, i, blockHeight * (numColumns-1), 0);              //creating a line (x,y,z)
      popMatrix();                                                   // going back to previos projection matrix
    }           
    for ( int i = 0; i < blockHeight* numColumns; i+= blockHeight)
    {
      pushMatrix();
      translate(constantMarginOnRows, constantMarginOnColumns); 
      line ( 0, i, 0, blockWidth* numRows, i, 0);
      popMatrix();
    }
  }


  //displaying the cells                        
  for ( int  i = 0; i< numRows; i++)
  {  
    for ( int  j= 0; j< numColumns-1; j++)
    {
      if ( dataMatrix[i][j]!=0)
      {
        noStroke();
        colorMode(HSB);
        fill (0, 255, dataMatrix[i][j]*255/ maxCount, 128);                    // setting up a color for the box
        pushMatrix();                                                          // doing the same for all the boxes, sadly that is the only way to do this
        translate(constantMarginOnRows, constantMarginOnColumns);              // translating coordiantes

          float zTranslation = (dataMatrix[i][j]*255/ maxCount) * 1;
        //rotateY(radians(30));
        float circleMapping = map(i, 0, numRows/4, 0, 2*PI);
        translate( sin(circleMapping)*1000, j* blockHeight - (i*(blockHeight/1.5f)), cos(circleMapping)*1000 +(zTranslation*1));     // translating coordiantes to box position     
        // note the movement in z position, it is half of the box's z length, this is because the box is drawn at the center
        //box( blockWidth, blockHeight, (dataMatrix[i][j])* 3  );                                                      // creating a cube of appropriate size 
        box( blockWidth, blockHeight, blockHeight );   
        // floating boxes instad of bar graphs

        // drawing text over the boxes
        if ( numberFlag)
        {
          // box values
          translate( 0, 0, blockHeight/2 + 2 );     // translating coordiantes to box position                      
          textFont(myFutura12);
          textAlign(CENTER, CENTER);
          fill(0);       
          text( dataMatrix[i][j], 0, 0 );
        }

        popMatrix();
      }
    }
  }

  //supporting text
  // nochanges required here. As this is being drawn at the base plane

  if ( textFlag)
  {
    for ( int  i = 0; i< numColumns-1; i++)   // y varies
    {
      textFont(myFutura16);
      textAlign(CENTER, CENTER);
      fill(64, 192);       
      text( categories[i], constantMarginOnRows*0.5f, constantMarginOnColumns + blockHeight * i  +  blockHeight/2 );
    }


    for ( int  i = 0; i< numRows; i++)   // y varies
    {
      textFont(myFutura16);
      textAlign(CENTER, CENTER);
      fill(64, 192);        
      text( (i%12)+1, constantMarginOnRows + i*blockWidth + blockWidth/2, constantMarginOnColumns + blockHeight * numColumns );   
      if (i<8) {
        text( years[i], constantMarginOnRows + i*(blockWidth*12) + blockWidth/2, constantMarginOnColumns + blockHeight*1.1f * numColumns );
      }
    }



    textFont(myFutura20);
    textAlign(LEFT, CENTER);
    fill(64);

    text( "2D Spacial Graph Demo: Monthly checkouts of electronic mediums in the religion/philosophy section ", constantMarginOnRows, constantMarginOnColumns/2 );
  }
}      // end of draw

public void keyPressed()
    {
      
      if ( key == 't')
            {
              textFlag= !textFlag;
            }
      
      if ( key == 'l')
            {
               lineFlag = !lineFlag;
            }
      
      if ( key == 'n');
          {
            numberFlag = !numberFlag;
          }

      if(key == ' ')
          saveFrame( "images/####.jpg");     
    }
    
public void setup()
{
  
  size(1440,900,OPENGL);                      // setting up the size of window
  
  if (frame != null) {
    frame.setResizable(true);          // resizable window
  }
  
  //setting up the camera
  cam= new PeasyCam( this,0,-1000,0,3000);       // (this, x,y,z, distance) (of camera)
  cam.setMinimumDistance(100);        // lower limit of camera distance to origin
  cam.setMaximumDistance(6000);       // higher limit of camera distance to origin
        
        
        
  background(240);                     //set background to white
  //noLoop();                            //to run draw() only once
  table = new Table();                 //allocating memory to new table 
  table = loadTable("GodB.csv", "header");  //loading table
  
  numRows = table.getRowCount();        //getting number of rows in the table
  numColumns = table.getColumnCount();  //getting the number of columns in table
  
  dataMatrix = new int [numRows][numColumns];  //allocating memory to the internal 2D array
  
  //copying the table data into 2D array
  for ( int  i = 0 ; i< numRows ; i++)
      {
        for ( int  j= 1 ; j< numColumns ; j++)
            {
              dataMatrix[i][j-1]  = table.getInt(i,j);          // - 1 as the first column is the day number             
              println("data value: "+ dataMatrix[i][j-1]);              
            }
      }
      
   println("data transferred");
   
   //finding the maximum count in the data
   
   maxCount = dataMatrix[0][0];   
    for ( int  i = 0 ; i< numRows ; i++)
      {
        for ( int  j= 1 ; j< numColumns ; j++)
            {
             if(maxCount<dataMatrix[i][j])
              {
                maxCount=dataMatrix[i][j];
              }
              
            }
      }
      
   println ( "maximum value is:"+ maxCount);
   println ( "rowCount: "+ numRows);
   println ( "columnCount: "+ numColumns);
   
}  
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "matthias_project_4" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
