
void drawGUI() {
  currentCameraMatrix = new PMatrix3D(g3.camera);
  camera();
  cP5.draw();
  g3.camera = currentCameraMatrix;

  colorMode(RGB);
  fill(fontColor);
  textFont(myFutura30); 
  textAlign(LEFT, CENTER);
  text("Time and Space", p5Margin, p5Margin*1.2);
  textFont(myFutura12); 
  text("Number of checkouts of titles that contain \ntemporal language, spatial language and both", p5Margin, p5Margin*2.5);

  labelYPosition = height/2.0;
  if (textFlag) {
    textFont(myFutura12);
    textAlign(LEFT, CENTER);
    
    text("label size", p5Margin + buttonWidth+5, p5Margin+7 + 6*p5Distance);
    text("label opacity", p5Margin + buttonWidth+5, p5Margin+7 + 7*p5Distance);
    text("checkout value", p5Margin + buttonWidth+5, p5Margin+7 + 8*p5Distance);
    text("time scaler", p5Margin + buttonWidth+5, p5Margin+7 + 9*p5Distance);
    text("cell size", p5Margin + buttonWidth+5, p5Margin+7 + 10*p5Distance);

    text("Invert color", p5Margin, p5Margin+7 + 11.5*p5Distance);
    
    text("Temporal language", p5Margin, labelYPosition/1.4 + buttonHeight*2 - 5);
    text("Spatial language", p5Margin, labelYPosition/1.4 + buttonHeight*3 - 5);
    text("Trans language", p5Margin, labelYPosition/1.4 + buttonHeight*4 - 5);
  }
}

void setupGUI() {
  cP5 = new ControlP5(this);
  cP5.setFont(myFutura12);
  cP5.setColorLabel(255);          
  cP5.addButton("Labels", 1.0, p5Margin, p5Margin + 5 * p5Distance, buttonWidth, buttonHeight);    

  cP5.addSlider("label size")
    .setPosition(p5Margin, p5Margin + 6 * p5Distance)
      .setSize(buttonWidth, buttonHeight)
        .setRange(0, 1)
          .setValue(0.25)
            .setLabel("")
              ;
  //cP5.addSlider("label size", 0, 1, labelScaler, p5Margin, p5Margin + 5 * p5Distance, buttonWidth, buttonHeight);
  cP5.addSlider("label opacity")
    .setPosition(p5Margin, p5Margin + 7 * p5Distance)
      .setSize(buttonWidth, buttonHeight)
        .setRange(0, 1)
          .setValue(0.25)
            .setLabel("")
              ;
  //cP5.addSlider("label opacity", 0, 1, labelOpacityScaler, p5Margin, p5Margin + 6 * p5Distance, buttonWidth, buttonHeight);  
  cP5.addSlider("checkout value")
    .setPosition(p5Margin, p5Margin + 8 * p5Distance)
      .setSize(buttonWidth, buttonHeight)
        .setRange(0, 5)
          .setValue(1.0)
            .setLabel("")
              ;
  //cP5.addSlider("checkout value", 0, 5, zTransformScaler, p5Margin, p5Margin + 7 * p5Distance, buttonWidth, buttonHeight);
  cP5.addSlider("time scaler")
    .setPosition(p5Margin, p5Margin + 9 * p5Distance)
      .setSize(buttonWidth, buttonHeight)
        .setRange(0, 100)
          .setValue(50)
            .setLabel("")
              ;
  //cP5.addSlider("time scaler", 0, 100, yScaler, p5Margin, p5Margin + 8 * p5Distance, buttonWidth, buttonHeight);
  cP5.addSlider("cell size")
    .setPosition(p5Margin, p5Margin + 10 * p5Distance)
      .setSize(buttonWidth, buttonHeight)
        .setRange(0, 5)
          .setValue(1.0)
            .setLabel("")
              ;
  //cP5.addSlider("cell size", 0, 5, cellSizeScaler, p5Margin, p5Margin + 9 * p5Distance, buttonWidth, buttonHeight);

  cP5.addToggle("invertColorFlag")
    .setPosition(p5Margin + (buttonWidth-buttonHeight), p5Margin + 11.5*p5Distance)
      .setSize(buttonHeight, buttonHeight)
        .setColorBackground(color(#000000))
          .setColorForeground(color(#868686))
            .setColorActive(color(#FFFFFF))
              .setLabel("")
                .setValue(false)
                  ;
  cP5.addToggle("timeFlag")
    .setPosition(p5Margin + (buttonWidth-buttonHeight), labelYPosition + buttonHeight*3 + 2)
      .setSize(buttonHeight, buttonHeight)
        .setColorBackground(color(#E3D6C9))
          .setColorForeground(color(#B98452))
            .setColorActive(color(#C19973))
              .setLabel("")
                .setValue(true)
                  ;
  cP5.addToggle("spaceFlag")
    .setPosition(p5Margin + (buttonWidth-buttonHeight), labelYPosition + buttonHeight*4 + 4)
      .setSize(buttonHeight, buttonHeight)
        .setColorBackground(color(#B2DEFF))
          .setColorForeground(color(#62A6D8))
            .setColorActive(color(#1C9DFC))
              .setLabel("")
                .setValue(true)
                  ;
  cP5.addToggle("transFlag")
    .setPosition(p5Margin + (buttonWidth-buttonHeight), labelYPosition + buttonHeight*5 + 6)
      .setSize(buttonHeight, buttonHeight)
        .setColorBackground(color(#F0A0A2))
          .setColorForeground(color(#FA797D))
            .setColorActive(color(#CE3E43))
              .setLabel("")
                .setValue(true)
                  ;
  cP5.setAutoDraw(false);
}  

void controlEvent(ControlEvent theEvent) {
  if (theEvent.isController()) {
    if (theEvent.controller().name()=="Text") {
      textFlag = !textFlag;
    }
    if (theEvent.controller().name()=="Numbers") {
      numberFlag =!numberFlag;
    }  
    if (theEvent.controller().name()=="Labels") {
      lineFlag =!lineFlag;
    }    
    if (theEvent.controller().name()=="label size") {
      labelScaler = theEvent.controller().value() ;
    }
    if (theEvent.controller().name()=="label opacity") {
      labelOpacityScaler = theEvent.controller().value() ;
    }
    if (theEvent.controller().name()=="checkout value") {
      zTransformScaler = theEvent.controller().value() ;
    }
    if (theEvent.controller().name()=="time scaler") {
      yScaler = theEvent.controller().value() ;
    } 
    if (theEvent.controller().name()=="cell size") {
      cellSizeScaler = theEvent.controller().value() ;
    } 

    print("control event from : "+theEvent.controller().name());
    println(", value : "+theEvent.controller().value());
  }
}

