void draw() {
  background(backgroundColor);
  translate( -width/2, -height/2 + yScaler*5); 
  rotateY(radians(75));

  //float mouseScaler = map(mouseX, 0, width, 0, 255); 

  if (cP5.window(this).isMouseOver()) {
    cam.setActive(false);
  } else {
    cam.setActive(true);
  }

  if (invertColorFlag==true) {
    backgroundColor = 0; 
    fontColor = 200;
  } else if (invertColorFlag==false) { 
    backgroundColor = 255; 
    fontColor = 64;
  }
  //displaying the cells                        
  for (int i=0; i<numRows; i++) {  
    for (int j=0; j<numColumns; j++) {
      noStroke();
      colorMode(HSB);

      if (j%3==0) {
        if (timeFlag==false) { 
          noFill();
        } else {
          fill(10, 48, 255 - dataMatrix[i][j]*255/maxCount, 128);
        }
      } else if (j%3==1) {
        if (spaceFlag==false) { 
          noFill();
        } else {
          fill(150, dataMatrix[i][j]*255/maxCount, dataMatrix[i][j]*255/maxCount, 128);
        }
      } else if (j%3==2) {
        if (transFlag==false) { 
          noFill();
        } else {
          fill(0, dataMatrix[i][j]/1.25, dataMatrix[i][j]/2, 128);
        }
      }
      pushMatrix();                                                         
      translate(rowMargin, columnMargin - yScaler/2);              
      float zTranslation = (dataMatrix[i][j]*255/maxCount) * zTransformScaler;
      float circleMapping = map(i, 0, numRows/8, 0, 2*PI);
      translate(sin(circleMapping)*2*(1 + zTranslation), j*cellHeight - (i*(cellHeight/1000)*yScaler), cos(circleMapping)*2*(1 + zTranslation));  
      box(cellWidth*0.25*cellSizeScaler, cellHeight*10*dataMatrix[i][j]/maxCount*cellSizeScaler, cellWidth*0.25*cellSizeScaler);  
      //ellipse(0, 0, cellSizeScaler*5, cellSizeScaler*5);
      //sphere(cellWidth*1*cellSizeScaler);
      // drawing text over the boxes
      if (numberFlag) {
        pushMatrix();
        translate( 0, 0, cellHeight/2 + 2 );                          
        textFont(myFutura12);
        textAlign(CENTER, CENTER);
        fill(fontColor);       
        text( dataMatrix[i][j], 0, 0 );
        popMatrix();
      }
      popMatrix();
    }
    pushMatrix();
    rotateX(radians(90));
    ellipseMode(CENTER);
    if (i%365==0 && yScaler >= 3.0 && lineFlag) {
      noFill();
      noStroke();
      fill((fontColor-64), 20*labelOpacityScaler*5); 
      // draw circles
      translate(rowMargin - cellWidth, columnMargin - cellWidth*10, i*yScaler/200 - 100);
      if (i > 0) {
        stroke(fontColor-64, 64);
        ellipse(0, 0, 250*5*labelScaler, 250*5*labelScaler);
      }
      stroke(fontColor, 128);
      line(0, 0, 0, 250*5*labelScaler/2);
      // draw rectangles
      pushMatrix();
      rotateY(radians(90));
      translate(-yScaler*2, 0, 0);
      noStroke();
      fill((fontColor-64), 5*labelOpacityScaler*5);
      noFill();
      rect(0, 0, (i*yScaler/200)+yScaler*2, 250*5*labelScaler/2);
      // print year text
      if (textFlag) {
        pushMatrix();
        rotateX(radians(180));
        fill(fontColor);
        textFont(myFutura30);
        scale(yScaler/100);
        textAlign(LEFT, CENTER);
        text(years[i/365], 50, -200);
        popMatrix();
      }
      popMatrix();
    }
    popMatrix();
  }
  drawGUI();
}     

