void setup() {  
  size(1440, 900, P3D);                    

  hint(DISABLE_DEPTH_TEST);
  if (frame != null) {
    frame.setResizable(true);  // resizable window
  }

  //setting up the camera
  cam= new PeasyCam( this, -700, -475, 0, 700);       // (this, x,y,z, distance) (of camera)
  cam.setMinimumDistance(100);        // lower limit of camera distance to origin
  cam.setMaximumDistance(10000);       // higher limit of camera distance to origin

  cP5 = new ControlP5(this); 
  g3 = (PGraphics3D)g;     
  setupGUI();

  background(240);                     

  table = new Table();                  
  table = loadTable("TimeSpace.csv", "header");  

  numRows = table.getRowCount();        
  numColumns = table.getColumnCount();  

  dataMatrix = new int [numRows][numColumns];  

  for (int i=0; i<numRows; i++) {
    for (int j=0; j<numColumns; j++) {
      dataMatrix[i][j] = table.getInt(i, j);               
      //println("data value: "+ dataMatrix[i][j]);
    }
  }

  println("data transferred");

  maxCount = dataMatrix[0][0];   
  for (int i=0; i<numRows; i++) {
    for (int j=0; j<numColumns; j++) {
      if (maxCount<dataMatrix[i][j]) {
        maxCount=dataMatrix[i][j];
      }
    }
  }

  println ("maximum value is:"+ maxCount);
  println ("rowCount: "+ numRows);
  println ("columnCount: "+ numColumns);
}  

